#!/bin/sh
# Maintained by: toleda for: github.com/toleda/
# File: audio_hdmi_hd5k_azul-90_patch.command_v1.1
# Credit: PikeRAlpha
#
# Desktop HD4600 HDMI audio AppleIntelFramebufferAzul.kext edit
# Edits Azul framebuffer 03 00 22 0D for HDMI audio, additional dsdt edits/ssdt required
# The patch enables DP, HDMI, 2XHDMI and DVI audio, however, the maximum number of audio  # devices supported is 2.
#
# NOTES: 
# 1. This patch does not back up the installed kext, backup before you proceed.
# 2. Run this patch file only once on a AppleIntelFramebufferAzul.kext,
#
# Requirements
# 1. 10.9 or newer
# 2. Haswell/HD4600/HD5000 Graphics
# 3. AppleIntelFramebufferAzul.kext_v8.18.26 or newer
#
# Installation
# 1. Downloads/audio_hdmi_hd5k_azul-90_patch.command
# 2. Double click audio_hdmi_hd5k_azul-90_patch.command
# 3. Enter password at prompt
#
echo " "
echo "Agreement"
echo "The audio_hdmi_hd5k_azul-90_patch is for personal use only.  Do not distribute"
echo "the patch or the resulting patched AppleIntelFramebufferAzul.kext for any" 
echo "reason without permission. The audio_hdmi_azul-90_patch is provided as is and"
echo "without any kind of warranty."
echo " "
echo "audio_hdmi_hd5k_azul-90_patch.command_v1.1"
echo "Patch binary ..."
sudo perl -pi -e 's|\x99\x14\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x05\x12\x00\x00\x04\x00\x00\x87\x00\x00\x00\x02\x04\x14\x00\x00\x04\x00\x00\x87\x00\x00\x00\x03\x06\x10\x00\x00\x04\x00\x00\x11\x00\x00\x00\xFF\x00\x01\x00\x01\x00\x00\x00\x40\x00\x00\x00|\x99\x14\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x05\x12\x00\x00\x04\x00\x00\x07\x01\x00\x00\x02\x04\x14\x00\x00\x08\x00\x00\x06\x00\x00\x00\x03\x06\x12\x00\x00\x08\x00\x00\x06\x00\x00\x00\xFF\x00\x01\x00\x01\x00\x00\x00\x40\x00\x00\x00|g' /System/Library/Extensions/AppleIntelFramebufferAzul.kext/Contents/MacOS/AppleIntelFramebufferAzul

echo "Fix permissions ..."
sudo chown -R root:wheel /System/Library/Extensions/AppleHDA.kext

echo "Kernel cache..."
sudo touch /System/Library/Extensions

echo "Finished, restart required."